#include "cf.h"


// Command registers               //standart        //this is nead becouse we start from A1, not from A0
#define CMD_DATA	 0x0       //0x00              //0x0
#define CMD_ERROR	 0x2       //0x01              //0x2
#define CMD_FEATURES	 0x2       //0x01              //0x2
#define CMD_SECT_CNT	 0x4       //0x02              //0x4
#define CMD_SECT_NUM	 0x6       //0x03              //0x6
#define CMD_CYL_LOW	 0x8       //0x04              //0x8
#define CMD_CYL_HIGH	 0xA       //0x05              //0xA
#define CMD_DEV_HEAD	 0xD       //0x06              //0xD
#define CMD_STATUS	 0xE       //0x07              //0xE
#define CMD_COMMAND	 0xE       //0x07              //0xE


void Delayc (unsigned long a) { while (--a!=0); }

unsigned short *p_Add   = (unsigned short*)CF_BASE_CS1;

unsigned short  cis[180]        = { 0 };
unsigned short  cf_buffer[256]  = { 0 };

void InitCF()
{
  //SET 16 bit mode
  unsigned long *s = (unsigned long*)0x78300000;
  *s = 0x80;
  //max speed
  IO23ACY_bit.IO23TYPE = 0x7;

  //CF initialization

}

void CF_Write_Byte(unsigned long Add, unsigned short uiData)
{
  //write
  p_Add  = (unsigned short*)(CF_BASE_CS2+Add);
  *p_Add = uiData;
}

unsigned short CF_Read_Byte(unsigned long Add)
{
  //p_Add  = (unsigned short*)(CF_BASE_CS2+Add);
  //return *p_Add;

  unsigned short ch;
  p_Add  = (unsigned short*)(CF_BASE_CS2+Add);
  ch = *p_Add;
  return ch;

}

//void ReadCardInf(unsigned short* cis)
void ReadCardInf()
{
  unsigned int i=0;

  for (i=0;i<180;i++)
  {
    cis[i]=*(unsigned short*)(CF_BASE_CS2+i*2);// CIS can be access in even address only
  }
}

void ResetCF()
{
   GPPMB_bit.GPPMB5 = 1;  //bit 6 - output


   Delayc(150000);
   GPPOB_bit.GPPOB5 = 1; //set reset pin to HIGH
   Delayc(1500);
   GPPOB_bit.GPPOB5 = 0; //set reset pin to LOW


}

void WriteBlock(unsigned int addr)
{

  unsigned char  temp   = 0;
  unsigned short i      = 0;

    /**** Write Sector  ****/
    //Set sector count
    //p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_SECT_CNT);
    //*p_Add = 0x1;
    *(unsigned char*)(CF_BASE_CS1 + CMD_SECT_CNT) = 0x1;  //sector count =1

    //Set the LBA address of memory block to be written
    //LBA [7:0] =1
    //p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_SECT_NUM);
    //*p_Add = 0x1;
    *(unsigned char*)(CF_BASE_CS1 + CMD_SECT_NUM) = 0x1;  //LBA [7:0] =1

    //LBA [15:8:] =0
    //p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_CYL_LOW);
    //*p_Add = 0x0;
    *(unsigned char*)(CF_BASE_CS1 + CMD_CYL_LOW) = 0x0;  //LBA [15:8:] =0

    //LBA [23:16:] =0
    //p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_CYL_HIGH);
    //*p_Add = 0x0;
    *(unsigned char*)(CF_BASE_CS1 + CMD_CYL_HIGH) = 0x0;  //LBA [23:16:] =0

    //LBA [27:24]=0 (lower 4 bit of register)
    //p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_DEV_HEAD);
    //*p_Add = 0xE0;
    *(unsigned char*)(CF_BASE_CS1 + CMD_DEV_HEAD) = 0xE0;  //LBA [27:24]=0

    //Issue write command
    //issue 30H command for sector write
    //p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_COMMAND);
    //*p_Add = 0x30;
    *(unsigned char*)(CF_BASE_CS1 + CMD_COMMAND) = 0x30; //issue 30H command for sector write

    //Poll for busy bit
    temp = *(unsigned short*)(CF_BASE_CS1 + CMD_STATUS);
    //poll for busy bit (bit 7 of register), quit loop when busy bit =0
    while (temp&0x80)
    {
      temp = *(unsigned short*)(CF_BASE_CS1 + CMD_STATUS);
    }


    //Write data to data buffer until DRQ is clear
    for (i=0;(temp&0x08)==0x08;i++) {
      p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_DATA);
      // write 2 byte of data to data buffer
      //*p_Add = 0xEEEE;
      *p_Add = cf_buffer[0];
      // poll for DRQ (bit 3 of register)
      temp = *(unsigned short*)(CF_BASE_CS1 + CMD_STATUS);
    }



}


void ReadBlock(unsigned int addr)
{

  unsigned char  temp   = 0;
  unsigned short i      = 0;

    /**** Read Sector  ****/
    //Set sector count
    //p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_SECT_CNT);
    //*p_Add = 0x1;
    *(unsigned char*)(CF_BASE_CS1 + CMD_SECT_CNT) = 0x1;  //sector count =1

    //Set the LBA address of memory block to be written
    //LBA [7:0] =1
    //p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_SECT_NUM);
    //*p_Add = 0x1;
    *(unsigned char*)(CF_BASE_CS1 + CMD_SECT_NUM) = 0x1;  //LBA [7:0] =1

    //LBA [15:8:] =0
    //p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_CYL_LOW);
    //*p_Add = 0x0;
    *(unsigned char*)(CF_BASE_CS1 + CMD_CYL_LOW) = 0x0;  //LBA [15:8:] =0

    //LBA [23:16:] =0
    //p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_CYL_HIGH);
    //*p_Add = 0x0;
    *(unsigned char*)(CF_BASE_CS1 + CMD_CYL_HIGH) = 0x0;  //LBA [23:16:] =0

    //LBA [27:24]=0 (lower 4 bit of register)
    //p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_DEV_HEAD);
    //*p_Add = 0xE0;
    *(unsigned char*)(CF_BASE_CS1 + CMD_DEV_HEAD) = 0xE0;  //LBA [27:24]=0


    //Issue read command
    //issue 20H command for sector write
    //p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_COMMAND);
    //*p_Add = 0x20;
    *(unsigned char*)(CF_BASE_CS1 + CMD_COMMAND) = 0x20; //issue 20H command for sector write


    //Poll for busy bit
    temp = *(unsigned short*)(CF_BASE_CS1 + CMD_STATUS);
    //poll for busy bit (bit 7 of register), quit loop when busy bit =0
    while (temp&0x80)
    {
      temp = *(unsigned char*)(CF_BASE_CS1 + CMD_STATUS);
    }

    //Read data from data buffer until DRQ is clear
    for (i=0;(temp&0x08)==0x08;i++) {
      p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_DATA);
      // read 2 byte of data to data buffer
      cf_buffer[i] = *p_Add;
      // poll for DRQ (bit 3 of register)
      temp = *(unsigned char*)(CF_BASE_CS1 + CMD_STATUS);
    }
}

void EraseBlock(unsigned int addr)
{

  unsigned char  temp   = 0;
  //unsigned short i      = 0;

    /**** Read Sector  ****/
    //Set sector count
    //p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_SECT_CNT);
    //*p_Add = 0x1;
    *(unsigned char*)(CF_BASE_CS1 + CMD_SECT_CNT) = 0x1;  //sector count =1

    //Set the LBA address of memory block to be written
    //LBA [7:0] =1
    //p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_SECT_NUM);
    //*p_Add = 0x1;
    *(unsigned char*)(CF_BASE_CS1 + CMD_SECT_NUM) = 0x1;  //LBA [7:0] =1

    //LBA [15:8:] =0
    //p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_CYL_LOW);
    //*p_Add = 0x0;
    *(unsigned char*)(CF_BASE_CS1 + CMD_CYL_LOW) = 0x0;  //LBA [15:8:] =0

    //LBA [23:16:] =0
    //p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_CYL_HIGH);
    //*p_Add = 0x0;
    *(unsigned char*)(CF_BASE_CS1 + CMD_CYL_HIGH) = 0x0;  //LBA [23:16:] =0

    //LBA [27:24]=0 (lower 4 bit of register)
    //p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_DEV_HEAD);
    //*p_Add = 0xE0;
    *(unsigned char*)(CF_BASE_CS1 + CMD_DEV_HEAD) = 0xE0;  //LBA [27:24]=0


    //Issue read command
    //issue 20H command for sector write
    //p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_COMMAND);
    //*p_Add = 0x20;
    *(unsigned char*)(CF_BASE_CS1 + CMD_COMMAND) = 0xC0; //issue 20H command for sector write


    //Poll for busy bit
    temp = *(unsigned short*)(CF_BASE_CS1 + CMD_STATUS);
    //poll for busy bit (bit 7 of register), quit loop when busy bit =0
    while (temp&0x80)
    {
      temp = *(unsigned char*)(CF_BASE_CS1 + CMD_STATUS);
    }
/*
    //Read data from data buffer until DRQ is clear
    for (i=0;(temp&0x08)==0x08;i++) {
      p_Add  = (unsigned short*)(CF_BASE_CS1 + CMD_DATA);
      // read 2 byte of data to data buffer
      cf_buffer[i] = *p_Add;
      // poll for DRQ (bit 3 of register)
      temp = *(unsigned char*)(CF_BASE_CS1 + CMD_STATUS);
    }
*/
}

